#include <iostream>
#include <fstream>
#include <chrono>
#include <thread>

namespace globals
{
    namespace mutex {
        std::mutex vehicle_list_mutex;
        std::mutex entity_list_mutex;
        std::mutex target_bone_mutex;
        std::mutex freecam_mutex;
        std::mutex tracer_mutex;
        std::mutex bullet_impacts_mutex;
    }

    inline bool is_logged_in = false;
    inline bool use_key = false;
    inline std::string hwid;
    inline std::string ip;
    inline std::string name;
    inline bool error;

    inline std::vector<std::string> friend_list;
    inline std::vector<int> friend_list_id;
    inline int friend_list_type = 0; // 0: License | 1: Network ID
    inline int npc_identify_type = 0; // 0: Entity Type | 1: Player Info

    inline float f_accent_color[4] = { 0.f, 132.f / 255.f, 1.f, 1.f };




    inline Vector2 screen = { GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN) };
    inline Vector2 screen_center = { GetSystemMetrics(SM_CXSCREEN) / 2, GetSystemMetrics(SM_CYSCREEN) / 2 };

    inline ImVec2 menu_pos;
    inline ImVec2 menu_size;

    inline float run_speed = 1.f;
    inline float noclip_speed = 1.f;
    inline float walk_speed = 1.f;
    inline float swim_speed = 1.f;
    inline float acceleration = 1.f;
    inline float downforce = 1.f;
    inline float weapon_damage = 1.f;
    inline float melee_damage = 1.f;
    inline float brake_force = 1.f;

    inline int minimum_hp = 50;
    inline int heal_amount = 50;
    inline int heal_delay = 30;

    inline int minimum_armor = 50;
    inline int armor_amount = 50;
    inline int armor_delay = 30;
    inline int rapid_fire_amount = 10;

    inline int miss_chance = 0;
    inline int tracer_type = 0;
    inline int tracer_duration = 1;

    inline int healkey_health_amount = 200;
    inline int healkey_armor_amount = 100;


    inline int hour = 12;

    inline iVector2 smoothing = { 0,0 };
    inline int fov = 30;
    inline int oof_indicator_radius = 256;
    inline int ped_debug_health = 200;
    inline int cam_fov = 50;
    inline int aim_max_distance = 250;
    inline int player_alpha = 255;

    inline int recoil_type = 0; // 0 = hardcore | 1 = safe
    inline int spread_type = 0; // 0 = hardcore | 1 = safe

    inline int ammobar_width = 30;

    inline int bullet_impact_duration = 1;

    inline float fov_color[] = { 1.f, 1.f, 1.f };
    inline float filled_fov_color[] = { 1.f, 1.f, 1.f, .25f };
    inline float tracer_color[] = { 1.f, 1.f, 1.f };
    inline float bullet_impact_circle_color[] = { 1.f, 1.f, 1.f };
    inline float damage_number_color[] = { 1.f, 0.f, 0.f };
    inline float bullet_impact_hitmarker_color[] = { 1.f, 1.f, 1.f };
    inline float target_line_color[] = { 1.f, 1.f, 1.f };
    inline float crosshair_color[] = { 1.f, 1.f, 1.f, 1.f };
    inline float vehicle_primary_color[] = { 1.f, 1.f, 1.f };
    inline float vehicle_secondary_color[] = { 1.f, 1.f, 1.f };
    inline float ammobar_color[] = { 1.f, 1.f, 1.f };
    inline float particle_hit_color[] = { 1.f, 1.f, 1.f };
    inline float sky_color[] = { 0.01f, 0.01f, 0.01f };


    namespace windows
    {
        iVector2 watermark_position = { 10 , 10 };
        iVector2 spotify_widget = { 0, 0 };
    }

    inline int bone = 0;
    inline int kill_sound_effect = 0;
    inline int hit_sound_effect = 0;
    inline std::vector<bool> closest_bones_filter(9, true);
    inline std::vector<bool> vehicle_rain(2048, false);
    inline std::vector<bool> rainbow_vehicle(2048, false);

    namespace keys
    {
        inline int aim_key = 0x2;
        inline int triggerbot_key = 0x2;
        inline int magic_bullet_key = 0x0;
        inline int chams_key = 0x0;
        inline int force_body_key = 0x0;
        inline int heal_key = 0x0;
        inline int zoom_key = 0x0;
        inline int menu_key = 0x2D;
        inline int exit_key = 0x0;
        inline int noclip_key = 0x0;
        inline int explosive_melee_key = 0x0;
        inline int explosive_ammo_key = 0x0;
        inline int fire_ammo_key = 0x0;
    }

    namespace toggles
    {
        inline std::vector<bool> text_toggles(5, false); // "Health", "Armor", "Weapon Name", "Distance"
        inline bool discord_rpc = false;
        inline bool external_overlay = false;
        inline bool auto_heal = false;
        inline bool auto_armor = false;
        inline bool draw_snaplines = false;
        inline bool visible_check = false;
        inline bool draw_watermark = false;
        inline bool draw_skeleton = false;
        inline bool draw_joints = false;
        inline bool draw_healthbar = false;
        inline bool draw_health = false;
        inline bool hide_bar_if_zero = false;
        inline bool draw_weapon_name = false;
        inline bool draw_player_name = false;
        inline bool draw_distance = false;
        inline bool draw_net_id = false;
        inline bool draw_armorbar = false;
        inline bool draw_hat = false;
        inline bool draw_armor = false;
        inline bool draw_box = false;
        inline bool draw_filled_box = false;
        inline bool draw_fov = false;
        inline bool draw_filled_fov = false;
        inline bool draw_target_line = false;
        inline bool draw_player_info = false;
        inline bool force_night = false;
        inline bool draw_nearby_players_list = false;
        inline bool spotify_widget = false;
        inline bool draw_invisible_players_list = false;
        inline bool draw_oof_indicators = false;
        inline bool draw_lock_status = false;
        inline bool draw_driver_status = false;
        inline bool draw_vehicle_distance = false;
        inline bool draw_crosshair = false;
        inline bool draw_vehicle_names = false;
        inline bool draw_healthbar_vehicle = false;
        inline bool ignore_own_vehicle = false;
        inline bool godmode = false;
        inline bool player_alpha_modifier = false;
        inline bool invisible = false;
        inline bool heal_key = false;
        inline bool zoom_key = false;
        inline bool seatbelt = false;
        inline bool ignore_self_esp = false;
        inline bool ignore_dead_esp = false;
        inline bool ignore_dead_aim = false;
        inline bool ignore_friend_aim = false;
        inline bool ignore_without_weapon_aim = false;
        inline bool ignore_friend_esp = false;
        inline bool ignore_npc = false;
        inline bool ignore_npc_aim = false;
        inline bool aimbot = false;
        inline bool triggerbot = false;
        inline bool magic_bullet = false;
        inline bool no_recoil = false;
        inline bool no_spread = false;
        inline bool remove_range_limit = false;
        inline bool remove_reload = false;
        inline bool fast_reload = false;
        inline bool noclip = false;
        inline bool dynamic_healthbar = false;
        inline bool dynamic_healthbar_vehicle = false;
        inline bool streamproof = false;
        inline bool chams = false;
        inline bool explosive_ammo = false;
        inline bool explosive_melee = false;
        inline bool fire_ammo = false;
        inline bool super_jump = false;
        inline bool players_looking_warning = false;
        inline bool vehicle_godmode = false;
        inline bool rapid_fire = false;
        inline bool tracers = false;
        inline bool bullet_impact_circle = false;
        inline bool bullet_impact_hitmarker = false;
        inline bool friend_marker = false;
        inline bool target_marker = false;
        inline bool ammobar = false;
        inline bool freecam = false;
        inline bool override_fov = false;
        inline bool vehicle_rain = false;
        inline bool damage_numbers = false;
        inline bool kill_sound = false;
        inline bool hit_sound = false;
        inline bool hit_particles = false;
        inline bool horn_boost = false;
        inline bool vehicle_rain_every = false;
        inline bool rainbow_vehicle_every = false;
        inline bool crosshair_text_health = false;
        inline bool crosshair_text_armor = false;
        inline bool crosshair_text_target_health = false;
        inline bool crosshair_text_target_armor = false;

    }

    namespace esp
    {
        inline int bar_position = 0; // 0 = side | 1 = bottom

        inline int text_position = 0; // 0 = left | 1 = center
        inline int text_position_vehicle = 0; // 0 = left | 1 = center
        inline int skeleton_type = 0; // 0 = simple | 1 = complex
        inline int font = 0; // 0 = inter | 1 = pixel
        inline int filled_box_type = 0; // 0 = flat | 1 = gradient
        inline int box_type = 0; // 0 = 2d | 1 = corner // 2 = 3d
        inline int max_distance = 500;
        inline int vehicle_max_distance = 500;
        inline int max_distance_text = 250;

        inline float box_color[] = { 1.f, 1.f, 1.f };
        inline float friend_box_color[] = { 0.f, 1.f, 0.f };
        inline float target_box_color[] = { 1.f, 1.f, 1.f };
        inline float friend_filled_box_color[] = { 0.f, 1.f, 0.f, 0.3f };
        inline float target_filled_box_color[] = { 1.f, 1.f, 1.f, 0.3f };
        inline float text_color[] = { 1.f, 1.f, 1.f };
        inline float filled_box_color[] = { 1.f, 1.f, 1.f, 0.3f };
        inline float snaplines_color[] = { 1.f, 1.f, 1.f };
        inline float skeleton_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float joints_color[] = { 1.f, 1.f, 1.f, 1.f };

        inline float friend_skeleton_color[] = { 0.f, 1.f, 0.f, 1.f };
        inline float friend_joints_color[] = { 0.f, 1.f, 0.f, 1.f };

        inline float target_skeleton_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float target_joints_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float friend_marker_color[] = { 0.f, 1.f, 0.f, 1.f };
        inline float target_marker_color[] = { 1.f, 0.f, 0.f, 1.f };

        inline float healthbar_color[] = { 30 / 255.f, 152 / 255.f, 39 / 255.f };
        inline float healthbar_color_vehicle[] = { 30 / 255.f, 152 / 255.f, 39 / 255.f };

        inline float armorbar_color[] = { 38.f / 255.f, 142.f / 255.f, 176.f / 255.f };
        inline float hat_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float oof_indicator_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float visible_color[] = { 1.f, 1.f, 1.f, 1.f };
        inline float hidden_color[] = { 0.2f, 0.2f, 0.2f, 1.f };
    }

    namespace hotkey_bools
    {
        inline bool heal_key_bool = false;
        inline bool noclip_key_bool = false;
        inline bool explosive_melee_bool = false;
        inline bool explosive_ammo_bool = false;
        inline bool fire_ammo_bool = false;
        inline bool aim_key_bool = false;
        inline bool triggerbot_key_bool = false;
        inline bool force_body_key_bool = false;
        inline bool menu_key_bool = false;
        inline bool exit_key_bool = false;
        inline bool magic_bullet_key_bool = false;
        inline bool chams_key_bool = false;
    }

}
