#include <windows.h>
#include <winhttp.h>
#include <iostream>
#include <string>
#include <unordered_map>
#include <string>
#include <locale>
#include <codecvt>

namespace player_names
{
    std::unordered_map<int, std::string> player_license_map;
    std::unordered_map<int, std::string> player_name_map;

    std::string get_ip()
    {
        class Net
        {
        public:
            char IP[16];
        };

        Net pNet = memory::Read<Net>(memory::get_module_base_address(memory::process_id, "net.dll") + 0xC9A58);
        std::string result;

        return pNet.IP;
    }

    std::string get_port()
    {
        class port_c
        {
        public:
            char port[6];
        };

        uintptr_t nui_gsclient = memory::get_module_base_address(memory::process_id, "nui-gsclient.dll");
        port_c port = memory::Read<port_c>(nui_gsclient + 0x4E032);


        return port.port;
    }

    static size_t WriteCallback(void* contents, size_t size, size_t nmemb, void* userp) {
        ((std::string*)userp)->append((char*)contents, size * nmemb);
        return size * nmemb;
    }

    std::wstring string_to_wstring(const std::string& str)
    {
        std::wstring_convert<std::codecvt_utf8<wchar_t>, wchar_t> converter;

        return converter.from_bytes(str);
    }

    void populate_player_maps(const std::string& json_data)
    {
        auto j = nlohmann::json::parse(json_data);

        for (const auto& player : j) {
            int id = player["id"];
            std::string name = player["name"];

            std::string license_identifier;
            for (const auto& identifier : player["identifiers"]) {
                std::string identifier_str = identifier;
                if (identifier_str.find("license:") == 0) {
                    license_identifier = identifier_str;
                    break;
                }
            }

            player_name_map[id] = name;
            player_license_map[id] = license_identifier;
        }

    }

    void id_name_map_loop()
    {
        while (true)
        {
            Sleep(1000);
            if (!globals::is_logged_in || !game::world || !game::local_player)
            {
                continue;
            }

            std::string ip = get_ip();
            std::string port = get_port();

            std::string url_non_wide = "http://" + ip + ":" + port + "/players.json";


            if (ip == "51.210.222.170")
                url_non_wide = "https://fivem.net/2699/players.json";

            std::wstring url = string_to_wstring(url_non_wide);

            HINTERNET hSession = WinHttpOpen(L"A WinHTTP Example Program/1.0",
                WINHTTP_ACCESS_TYPE_DEFAULT_PROXY,
                WINHTTP_NO_PROXY_NAME,
                WINHTTP_NO_PROXY_BYPASS, 0);

            if (!hSession) {
                continue;
            }

            URL_COMPONENTS urlComp;
            ZeroMemory(&urlComp, sizeof(urlComp));
            urlComp.dwStructSize = sizeof(urlComp);

            wchar_t hostName[256];
            wchar_t urlPath[1024];

            urlComp.lpszHostName = hostName;
            urlComp.dwHostNameLength = _countof(hostName);
            urlComp.lpszUrlPath = urlPath;
            urlComp.dwUrlPathLength = _countof(urlPath);

            std::wstring wideUrl = url;
            if (!WinHttpCrackUrl(wideUrl.c_str(), 0, 0, &urlComp)) {
                WinHttpCloseHandle(hSession);
                continue;
            }

            HINTERNET hConnect = WinHttpConnect(hSession, urlComp.lpszHostName,
                urlComp.nPort, 0);
            if (!hConnect) {
                WinHttpCloseHandle(hSession);
                continue;
            }

            HINTERNET hRequest = WinHttpOpenRequest(hConnect, L"GET", urlComp.lpszUrlPath,
                NULL, WINHTTP_NO_REFERER,
                WINHTTP_DEFAULT_ACCEPT_TYPES,
                urlComp.nScheme == INTERNET_SCHEME_HTTPS ? WINHTTP_FLAG_SECURE : 0);

            if (!hRequest) {
                WinHttpCloseHandle(hConnect);
                WinHttpCloseHandle(hSession);
                continue;
            }

            if (!WinHttpSendRequest(hRequest, WINHTTP_NO_ADDITIONAL_HEADERS, 0,
                WINHTTP_NO_REQUEST_DATA, 0, 0, 0)) {
                WinHttpCloseHandle(hRequest);
                WinHttpCloseHandle(hConnect);
                WinHttpCloseHandle(hSession);
                continue;
            }

            if (!WinHttpReceiveResponse(hRequest, NULL)) {
                WinHttpCloseHandle(hRequest);
                WinHttpCloseHandle(hConnect);
                WinHttpCloseHandle(hSession);
                continue;
            }

            DWORD dwSize = 0;
            DWORD dwDownloaded = 0;
            std::string response;

            do {
                dwSize = 0;
                if (!WinHttpQueryDataAvailable(hRequest, &dwSize)) {
                    continue;
                }

                char* pszOutBuffer = new char[dwSize + 1];
                if (!pszOutBuffer) {
                    dwSize = 0;
                    continue;
                }

                ZeroMemory(pszOutBuffer, dwSize + 1);
                if (!WinHttpReadData(hRequest, (LPVOID)pszOutBuffer, dwSize, &dwDownloaded)) {
                    delete[] pszOutBuffer;
                    continue;
                }

                response.append(pszOutBuffer, dwDownloaded);
                delete[] pszOutBuffer;
            } while (dwSize > 0);

            WinHttpCloseHandle(hRequest);
            WinHttpCloseHandle(hConnect);
            WinHttpCloseHandle(hSession);

            populate_player_maps(response);


        }
    }

}
