namespace features
{
    struct bullet_impact {
        Vector3 end_pos;
        std::chrono::time_point<std::chrono::steady_clock> start_time;
        float initial_alpha = 255.0f;
        float current_alpha = 255.0f;
    };

    class Bullet_impacts_manager {
    public:
        void add_bullet_impact(Vector3 end_pos) {
            for (const auto& existing_bullet_impact : bullet_impacts) {
                if (existing_bullet_impact.end_pos == end_pos) {
                    return;
                }
            }
            bullet_impact new_bullet_impact{ end_pos, std::chrono::steady_clock::now() };
            bullet_impacts.push_back(new_bullet_impact);
        }

        void update_bullet_impact() {
            auto now = std::chrono::steady_clock::now();
            for (auto& bullet_impact : bullet_impacts) {
                auto elapsed = std::chrono::duration<float>(now - bullet_impact.start_time).count();
                if (elapsed > (globals::bullet_impact_duration - .4f)) {
                    float time_since_fade = elapsed - (globals::bullet_impact_duration - .4f);
                    bullet_impact.current_alpha = bullet_impact.initial_alpha * (globals::bullet_impact_duration - (time_since_fade / 0.2f));
                    if (bullet_impact.current_alpha < 0.0f) {
                        bullet_impact.current_alpha = 0.0f;
                    }
                }
            }
            bullet_impacts.erase(
                std::remove_if(bullet_impacts.begin(), bullet_impacts.end(), [&](const bullet_impact& bullet_impact) {
                    return bullet_impact.current_alpha == 0.0f;
                    }),
                bullet_impacts.end()
            );
        }

        std::vector<bullet_impact> get_bullet_impacts()
        {
            return bullet_impacts;
        }

    private:
        std::vector<bullet_impact> bullet_impacts;
    };

    Bullet_impacts_manager bullet_impacts_manager;

    void bullet_impacts()
    {
        static Vector3 last_impact;
        //static bool first = false;

        while (true)
        {
            Sleep(1);

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            std::lock_guard<std::mutex> lock(globals::mutex::bullet_impacts_mutex);

            bullet_impacts_manager.update_bullet_impact();


            uintptr_t weapon_manager = memory::Read<uintptr_t>(game::local_player + offsets::weapon_manager);

            if (!weapon_manager)
                continue;

            uintptr_t v2 = memory::Read<uintptr_t>(weapon_manager + 0x78);

            if (!v2)
                continue;

            uintptr_t v3 = memory::Read<uintptr_t>(v2 + offsets::c_weapon_offset);

            if (!v3)
                continue;

            Vector3 end_pos = memory::Read<Vector3>(weapon_manager + 0x1B0);

            //if (!first)
            //{
            //    end_pos = last_impact;
            //    first = true;
            //}

            if (end_pos == last_impact)
                continue;

            bullet_impacts_manager.add_bullet_impact(end_pos);

            last_impact = end_pos;
        }
    }
}
