enum e_types : uint32_t {
    PED = 0,
    VEHICLE = 1,
    NONE = 2
};

struct m_freecam_target {
    Vector3 v_origin;
    Vector2 v_s_origin;
    uint32_t m_type;
    float m_pixel_distance, m_distance;
    uint64_t m_pointer;
    int m_network_id;
};

m_freecam_target freecam_target;

namespace features {
    void free_cam()
    {
        static bool was_on = false;
        static int iteration_count = 0;
        static bool un_nop_needed = true;
        auto last_key_press_time = std::chrono::steady_clock::now();

        while (true)
        {
            std::this_thread::sleep_for(std::chrono::milliseconds(1));

            std::array<BYTE, 5> nop_array = { 0x90, 0x90, 0x90, 0x90, 0x90 };
            std::array<BYTE, 5> un_nop_array_x = { 0xF3, 0x0F, 0x11, 0x47, 0x60 };
            std::array<BYTE, 5> un_nop_array_y = { 0xF3, 0x0F, 0x11, 0x4F, 0x64 };
            std::array<BYTE, 5> un_nop_array_z = { 0xF3, 0x0F, 0x11, 0x47, 0x68 };

            uintptr_t model_info = memory::Read<uintptr_t>(game::local_player + 0x20);
            std::lock_guard<std::mutex> lock_freecam(globals::mutex::freecam_mutex);

            freecam_target.m_type = NONE;

            if (globals::toggles::freecam) {
                memory::Write<BYTE>(game::local_player + 0x2C, 0x1);
                std::lock_guard<std::mutex> lock_vehicle(globals::mutex::vehicle_list_mutex);
                float m_closest_distance = FLT_MAX;

                for (const auto& vehicle : vehicle_list::vehicle_list)
                {
                    float m_pixel_distance = calc::distance(vehicle.screen_position, globals::screen_center);

                    if (m_pixel_distance < m_closest_distance && m_pixel_distance <= 200.f) {
                        freecam_target.m_distance = calc::distance_v3(vehicle.origin, game::local_position);
                        freecam_target.m_pixel_distance = m_pixel_distance;
                        freecam_target.m_pointer = vehicle.ptr;
                        freecam_target.m_type = VEHICLE;
                        freecam_target.v_origin = vehicle.origin;
                        freecam_target.v_s_origin = vehicle.screen_position;
                        m_closest_distance = m_pixel_distance;
                    }
                }

                for (const auto& ped : entity_list::ped_list)
                {
                    float m_pixel_distance = calc::distance(ped.screen_position, globals::screen_center);

                    if (m_pixel_distance < m_closest_distance && m_pixel_distance <= 200.f) {
                        freecam_target.m_distance = calc::distance_v3(ped.origin, game::local_position);
                        freecam_target.m_pixel_distance = m_pixel_distance;
                        freecam_target.m_pointer = ped.m_pointer;
                        freecam_target.m_type = PED;
                        freecam_target.v_origin = ped.origin;
                        freecam_target.v_s_origin = ped.screen_position;
                        freecam_target.m_network_id = ped.net_id;
                        m_closest_distance = m_pixel_distance;
                    }
                }

                auto current_time = std::chrono::steady_clock::now();
                auto time_since_last_press = std::chrono::duration_cast<std::chrono::milliseconds>(current_time - last_key_press_time).count();

                if (time_since_last_press >= 250) {
                    if (GetAsyncKeyState(0x45)) // E KEY
                    {
                        last_key_press_time = current_time; // Update the last key press time

                        switch (freecam_target.m_type)
                        {
                        case PED:
                            globals::vehicle_rain[freecam_target.m_network_id] = !globals::vehicle_rain[freecam_target.m_network_id];
                            break;
                        case VEHICLE:
                        {
                            std::random_device rd;
                            std::mt19937 gen(rd());
                            std::uniform_int_distribution<> dist(0, 255);

                            network* net = network::instance();
                            net->network_request_control_of_entity(freecam_target.m_pointer, game::local_player);

                            int r = dist(gen);
                            int g = dist(gen);
                            int b = dist(gen);

                            uintptr_t mod = memory::Read<uintptr_t>(freecam_target.m_pointer + 0x48);
                            uintptr_t color = memory::Read<uintptr_t>(mod + 0x20);
                            if (freecam_target.m_pointer) {
                                memory::Write<int>(color + 0xA4, 0xFF000000 | (r << 16) | (g << 8) | b);
                                memory::Write<int>(color + 0xA8, 0xFF000000 | (r << 16) | (g << 8) | b);
                            }
                        }
                        break;
                        case NONE:
                            break;
                        }
                    }

                    if (GetAsyncKeyState(0x47)) // G KEY
                    {
                        last_key_press_time = current_time; // Update the last key press time

                        switch (freecam_target.m_type)
                        {
                        case PED:
                            break;
                        case VEHICLE:
                        {
                            network* net = network::instance();
                            net->network_request_control_of_entity(freecam_target.m_pointer, game::local_player);

                            memory::Write<float>(freecam_target.m_pointer + offsets::body_health, -1.f);
                            memory::Write<float>(freecam_target.m_pointer + offsets::tank_health, -1.f);
                        }
                        break;
                        case NONE:
                            break;
                        }
                    }

                    if (GetAsyncKeyState(0x48)) // H KEY
                    {
                        last_key_press_time = current_time; // Update the last key press time

                        switch (freecam_target.m_type)
                        {
                        case PED:
                            break;
                        case VEHICLE:
                        {
                            network* net = network::instance();
                            net->network_request_control_of_entity(freecam_target.m_pointer, game::local_player);

                            uintptr_t m_navigation = memory::Read<uintptr_t>(freecam_target.m_pointer + 0x30);

                            Vector3 v_sky = freecam_target.v_origin;
                            v_sky.z += 100;

                            memory::Write<Vector3>(freecam_target.m_pointer + 0x90, v_sky);
                            memory::Write<Vector3>(freecam_target.m_pointer + 0x50, v_sky);
                        }
                        break;
                        case NONE:
                            break;
                        }
                    }
                }

                if (iteration_count % 1000 == 0) {
                    std::array<BYTE, 5> current_nop_x = memory::Read<std::array<BYTE, 5>>(game::base + offsets::freecam_nop);
                    std::array<BYTE, 5> current_nop_y = memory::Read<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0xB);
                    std::array<BYTE, 5> current_nop_z = memory::Read<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0x16);

                    un_nop_needed = !(current_nop_x == un_nop_array_x && current_nop_y == un_nop_array_y && current_nop_z == un_nop_array_z);
                }

                if (un_nop_needed) {
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop, nop_array); // x nop
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0xB, nop_array); // y nop
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0x16, nop_array); // z nop
                }

                Vector3 new_pos = memory::Read<Vector3>(game::view_angles + 0x60);
                Vector3 angles = memory::Read<Vector3>(game::view_angles + 0x3D0);

                if (angles.is_zero())
                {
                    angles = memory::Read<Vector3>(game::view_angles + 0x40);
                }

                float cam_speed = 2.f;

                if (GetAsyncKeyState(0x57)) // W KEY
                {
                    new_pos.y += angles.y * cam_speed;
                    new_pos.x += angles.x * cam_speed;
                    new_pos.z += angles.z * cam_speed;
                }

                memory::Write<Vector3>(game::view_angles + 0x60, new_pos);

                Vector3 player_pos = { new_pos.x - 1, new_pos.y - 1, new_pos.z - 1 };
                memory::Write<Vector3>(game::local_player + 0x90, player_pos);
            }
            else {
                memory::Write<BYTE>(game::local_player + 0x2C, 0x37);

                // Ensure we only write `un_nop` arrays if they were changed or needed
                if (un_nop_needed) {
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop, un_nop_array_x); // x un_nop
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0xB, un_nop_array_y); // y un_nop
                    memory::Write<std::array<BYTE, 5>>(game::base + offsets::freecam_nop + 0x16, un_nop_array_z); // z un_nop
                }
            }

            iteration_count++;
        }
    }
}
