


namespace features
{
    std::string bone_names[9] = { "Head", "Left Foot", "Right Foot", "Left Ankle", "Right Ankle", "Left Hand", "Right Hand", "Neck", "Stomach" };

    std::string get_bone_impact(Vector3 bones[9], Vector3 last_impact)
    {
        float closest_distance = FLT_MAX;
        int nearest_index = -1;
        for (int bone_index = 0; bone_index < 9; bone_index++)
        {
            float distance = calc::distance_v3(last_impact, bones[bone_index]);
            if (distance < closest_distance)
            {
                closest_distance = distance;
                nearest_index = bone_index;
            }
        }


        return bone_names[nearest_index];
    }


    void hitlog()
    {
        int previous_health[256];

        Vector3 previous_last_impact;

        for (int i = 0; i < 256; i++) {
            previous_health[i] = -1;
        }

        while (true)
        {

            Sleep(1);
            std::lock_guard<std::mutex> lock(globals::mutex::entity_list_mutex);

            uintptr_t weapon_manager = memory::Read<uintptr_t>(game::local_player + offsets::weapon_manager);
            Vector3 last_impact = memory::Read<Vector3>(weapon_manager + 0x1B0);


            for (entity_list::ped_struct ped : entity_list::ped_list)
            {
                if (ped.health < previous_health[ped.index] && previous_health[ped.index] != -1) {
                    int damage = previous_health[ped.index] - ped.health;
                    if (previous_last_impact != last_impact && calc::distance_v3(last_impact, ped.origin) < 1.5f)
                    {
                        string name = ped.player_name;

                        if (name == "")
                            name = "Ped";

                        printa<hit>("Hit " + name + " in the " + get_bone_impact(ped.v_bones, last_impact) + " for " + std::to_string(damage) + " damage (" + std::to_string(ped.health) + " health remaining)" + "\n");


                        if (globals::toggles::hit_particles)
                        {
                            Vector2 last_impact_screen = calc::world_to_screen(last_impact);
                            overlay::pixel particle_col = colors::global_to_pixel(globals::particle_hit_color);
                            particleManager.addSuperParticle(last_impact, ImVec4(particle_col.R, particle_col.G, particle_col.B, 0));
                        }

                        if (ped.health > 0 && globals::toggles::hit_sound)
                        {
                            PlaySoundA(sounds::get_sound_by_id(globals::hit_sound_effect), NULL, SND_MEMORY | SND_ASYNC);
                        }

                        if (ped.health == 0 && globals::toggles::kill_sound)
                        {
                            PlaySoundA(sounds::get_sound_by_id(globals::kill_sound_effect), NULL, SND_MEMORY | SND_ASYNC);
                        }
                        previous_last_impact = last_impact;

                    }
                }
                previous_health[ped.index] = ped.health;
            }

        }
    }
}
