enum eVehicleLockState {
    VEHICLELOCK_NONE = 0, // No specific lock state, vehicle behaves according to the game's default settings.
    VEHICLELOCK_UNLOCKED = 1, // Vehicle is fully unlocked, allowing free entry by players and NPCs.
    VEHICLELOCK_LOCKED = 2, // Vehicle is locked, preventing entry by players and NPCs.
    VEHICLELOCK_LOCKOUT_PLAYER_ONLY = 3, // Vehicle locks out only players, allowing NPCs to enter.
    VEHICLELOCK_LOCKED_PLAYER_INSIDE = 4, // Vehicle is locked once a player enters, preventing others from entering.
    VEHICLELOCK_LOCKED_INITIALLY = 5, // Vehicle starts in a locked state, but may be unlocked through game events.
    VEHICLELOCK_FORCE_SHUT_DOORS = 6, // Forces the vehicle's doors to shut and lock.
    VEHICLELOCK_LOCKED_BUT_CAN_BE_DAMAGED = 7, // Vehicle is locked but can still be damaged.
    VEHICLELOCK_LOCKED_BUT_BOOT_UNLOCKED = 8, // Vehicle is locked, but its trunk/boot remains unlocked.
    VEHICLELOCK_LOCKED_NO_PASSENGERS = 9, // Vehicle is locked and does not allow passengers, except for the driver.
    VEHICLELOCK_CANNOT_ENTER = 10 // Vehicle is completely locked, preventing entry entirely, even if previously inside.
};

namespace features
{
    void teleport_to_vehicle(int index)
    {
        uintptr_t vehicle = memory::Read<uintptr_t>(game::vehicle_list + index * 0x10);

        Vector3 pos = memory::Read<Vector3>(vehicle + 0x90);

        pos.z += 2.f;

        uintptr_t navigation = memory::Read<uintptr_t>(game::local_player + 0x30);

        uintptr_t local_vehicle = memory::Read<uintptr_t>(game::local_player + 0xD30);
        uintptr_t vehicle_navigation = memory::Read<uintptr_t>(local_vehicle + 0x30);

        memory::Write<Vector3>(navigation + 0x50, pos);
        memory::Write<Vector3>(game::local_player + 0x90, pos);
        if (sdk::c_ped::in_vehicle(game::local_player))
        {
            memory::Write<Vector3>(vehicle + 0x90, pos);
            memory::Write<Vector3>(vehicle_navigation + 0x50, pos);
        }

    }

    void teleport_to_waypoint()
    {
        Vector2 waypoint_pos = memory::Read<Vector2>(game::base + offsets::waypoint_offset);

        waypoint_pos.print();

        if (waypoint_pos.x == 64000.f || waypoint_pos.y == 64000.f)
            return;

        for (int i = 0; i < 10; i++) {
            uintptr_t vehicle = memory::Read<uintptr_t>(game::local_player + offsets::vehicle_offset);
            uintptr_t vehicle_navigation = memory::Read<uintptr_t>(vehicle + 0x30);
            uintptr_t navigation = memory::Read<uintptr_t>(game::local_player + 0x30);

            Vector3 pos = { waypoint_pos.x, waypoint_pos.y, -200.f };

            if (game::local_ped.in_vehicle())
            {
                memory::Write<Vector3>(vehicle + 0x90, pos);
                memory::Write<Vector3>(vehicle_navigation + 0x50, pos);
            }

            memory::Write<Vector3>(game::local_player + 0x90, pos);
            memory::Write<Vector3>(navigation + 0x50, pos);
        }
    }

    void teleport_to_ped(Vector3 origin)
    {
        Vector3 pos = origin;

        pos.z += 2.f;

        uintptr_t navigation = memory::Read<uintptr_t>(game::local_player + 0x30);

        uintptr_t vehicle = memory::Read<uintptr_t>(game::local_player + 0xD30);
        uintptr_t vehicle_navigation = memory::Read<uintptr_t>(vehicle + 0x30);

        memory::Write<Vector3>(navigation + 0x50, pos);
        memory::Write<Vector3>(game::local_player + 0x90, pos);
        if (game::local_ped.in_vehicle())
        {
            memory::Write<Vector3>(vehicle + 0x90, pos);
            memory::Write<Vector3>(vehicle_navigation + 0x50, pos);
        }

    }

    void steal_outfit(int index)
    {
        //uintptr_t ped = entity_list::PedPool.GetAt(index);

        //uintptr_t drawhandler = memory::Read<uintptr_t>(ped + 0x48);

        //BYTE shoes = memory::Read<BYTE>(drawhandler + 0x100);
        //BYTE leg = memory::Read<BYTE>(drawhandler + 0xF8);
        //BYTE body = memory::Read<BYTE>(drawhandler + 0x114);
        //BYTE tshirt = memory::Read<BYTE>(drawhandler + 0x108);
        //BYTE mask = memory::Read<BYTE>(drawhandler + 0xEC);
        //BYTE hand = memory::Read<BYTE>(drawhandler + 0xF4);
        //BYTE bag = memory::Read<BYTE>(drawhandler + 0xFC);
        //BYTE armor = memory::Read<BYTE>(drawhandler + 0x10C);

        //uintptr_t local_drawhandler = memory::Read<uintptr_t>(game::local_player + 0x48);

        //memory::Write<BYTE>(local_drawhandler + 0x100, shoes);
        //memory::Write<BYTE>(local_drawhandler + 0xF8, leg);
        //memory::Write<BYTE>(local_drawhandler + 0x114, body);
        //memory::Write<BYTE>(local_drawhandler + 0x108, tshirt);
        //memory::Write<BYTE>(local_drawhandler + 0xEC, mask);
        //memory::Write<BYTE>(local_drawhandler + 0xF4, hand);
        //memory::Write<BYTE>(local_drawhandler + 0xFC, bag);
        //memory::Write<BYTE>(local_drawhandler + 0x10C, armor);
        //memory::Write<BYTE>(game::local_player + 0xAC, 0);
    }


    void change_vehicle_lock(int index, bool lock)
    {
        uintptr_t vehicle = memory::Read<uintptr_t>(game::vehicle_list + index * 0x10);

        int lock_int;

        if (lock)
            lock_int = eVehicleLockState::VEHICLELOCK_LOCKED;
        else
            lock_int = eVehicleLockState::VEHICLELOCK_UNLOCKED;

        memory::Write<uint32_t>(vehicle + offsets::vehicle_lock_offset, lock_int);

    }

    void teleport(Vector3 pos)
    {
        uintptr_t vehicle = memory::Read<uintptr_t>(game::local_player + offsets::vehicle_offset);
        uintptr_t vehicle_navigation = memory::Read<uintptr_t>(vehicle + 0x30);

        if (game::local_ped.in_vehicle())
        {
            memory::Write<Vector3>(vehicle + 0x90, pos);
            memory::Write<Vector3>(vehicle_navigation + 0x50, pos);
        }

        uintptr_t navigation = memory::Read<uintptr_t>(game::local_player + 0x30);

        memory::Write<Vector3>(navigation + 0x50, pos);
        memory::Write<Vector3>(game::local_player + 0x90, pos);


    }

    void self()
    {
        while (true)
        {
            Sleep(250);

            if (!globals::is_logged_in)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            game::player_info = memory::Read<uintptr_t>(game::local_player + offsets::playerinfo_offset);

            memory::Write<float>(game::player_info + offsets::run_speed_offset, globals::run_speed);
            memory::Write<float>(game::player_info + 0x1C8, globals::swim_speed);

            memory::Write<bool>(game::local_player + 0x189, globals::toggles::godmode);

            memory::Write<float>(game::player_info + 0x0D5C, globals::weapon_damage);
            memory::Write<float>(game::player_info + 0x0D6C, globals::melee_damage);

            if (globals::toggles::override_fov)
            {
                uintptr_t m_cam_data = memory::Read<uintptr_t>(game::view_angles + 0x10);

                memory::Write<float>(m_cam_data + 0x30, globals::cam_fov);
            }



        }
    }

    enum class eAmmoSpecialType : int32_t
    {
        None,
        ArmorPiercing,
        Explosive,
        FMJ,
        HollowPoint,
        Incendiary,
        Tracer
    };

    enum eFrameFlags : std::uint32_t {
        eFrameFlagExplosiveAmmo = 1 << 11,
        eFrameFlagFireAmmo = 1 << 12,
        eFrameFlagExplosiveMelee = 1 << 13,
        eFrameFlagSuperJump = 1 << 14,
    };

    void world()
    {
        while (true)
        {
            Sleep(1);

            if (!globals::is_logged_in)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            static std::array<BYTE, 2> unnop_array_x;
            static std::array<BYTE, 6> unnop_array_y;

            static bool unnops_retrieved = false;

            if (!unnops_retrieved)
            {
                unnop_array_x = memory::Read<std::array<BYTE, 2>>(game::base + offsets::time_nop_x);
                unnop_array_y = memory::Read<std::array<BYTE, 6>>(game::base + offsets::time_nop_y);
                unnops_retrieved = true;
            }

            if (globals::toggles::force_night)
            {
                std::array<BYTE, 2> nop_array_x = { 0x90, 0x90 };
                std::array<BYTE, 6> nop_array_y = { 0x90, 0x90, 0x90, 0x90, 0x90, 0x90 };
                memory::Write<std::array<BYTE, 2> >(game::base + offsets::time_nop_x, nop_array_x);
                memory::Write<std::array<BYTE, 6> >(game::base + offsets::time_nop_y, nop_array_y);
                memory::Write<uint32_t>(game::base + offsets::time_offset + 0x10, globals::hour); // hour 0 - 23
            }
            else {
                memory::Write<std::array<BYTE, 2> >(game::base + offsets::time_nop_x, unnop_array_x);
                memory::Write<std::array<BYTE, 6> >(game::base + offsets::time_nop_y, unnop_array_y);
            }

            //std::array<BYTE, 7> nop_array = { 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90 };

            //memory::Write<std::array<BYTE, 7> >(game::base + 0xE4322F, nop_array); // b2699 | 0F29 A2 B0000000

            //Vector3 sky_color = { globals::sky_color[0] * 255, globals::sky_color[1] * 255, globals::sky_color[2] * 255 };

            //memory::Write<Vector3>(game::base + 0x27E7A70 + 0xB0, sky_color); // b2699 | rip 48 8D 0D ? ? ? ? E8 ? ? ? ? 83 25 ? ? ? ? 00 48 8D 0D ? ? ? ? F3

        }
    }

    void weapon()
    {
        while (true)
        {
            Sleep(1);

            if (!globals::is_logged_in)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            uintptr_t weapon_manager = memory::Read<uintptr_t>(game::local_player + offsets::weapon_manager);
            uintptr_t weapon_info = memory::Read<uintptr_t>(weapon_manager + 0x20);

            if (globals::toggles::explosive_ammo || globals::toggles::explosive_melee || globals::toggles::fire_ammo || globals::toggles::super_jump) {
                uint32_t previous_frame_flags = memory::Read<uint32_t>(game::player_info + offsets::frame_flags_offset);
                memory::Write<uint32_t>(game::player_info + offsets::frame_flags_offset, previous_frame_flags |
                    (globals::toggles::explosive_ammo ? eFrameFlags::eFrameFlagExplosiveAmmo : 0) |
                    (globals::toggles::fire_ammo ? eFrameFlags::eFrameFlagFireAmmo : 0) |
                    (globals::toggles::explosive_melee ? eFrameFlags::eFrameFlagExplosiveMelee : 0) |
                    (globals::toggles::super_jump ? eFrameFlags::eFrameFlagSuperJump : 0));
            }

            float recoil_amount = 0.f;

            if (globals::recoil_type == 1)
                recoil_amount = 0.05f;

            if (globals::toggles::no_recoil)
                memory::Write<float>(weapon_info + offsets::recoil_offset, recoil_amount);

            float spread_amount = 0.f;

            if (globals::spread_type == 1)
                spread_amount = 0.05f;

            if (globals::toggles::no_spread)
                memory::Write<float>(weapon_info + offsets::spread_offset, spread_amount);
            if (globals::toggles::remove_range_limit)
                memory::Write<float>(weapon_info + offsets::range_offset, 99999.f);

            if (globals::toggles::rapid_fire)
                memory::Write<uint32_t>(weapon_info + 0x120, globals::rapid_fire_amount);
            else
                memory::Write<uint32_t>(weapon_info + 0x120, 1);

            if (globals::toggles::remove_reload)
                memory::Write<float>(weapon_info + offsets::reload_multiplier_offset, 100.f);

            if (globals::toggles::fast_reload)
                memory::Write<float>(weapon_info + offsets::reload_multiplier_offset, 3.f);

            if (!globals::toggles::fast_reload && !globals::toggles::remove_reload)
                memory::Write<float>(weapon_info + offsets::reload_multiplier_offset, 1.f);
        }
    }

    void vehicle()
    {
        while (true)
        {
            Sleep(250);
            if (!globals::is_logged_in)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            if (!game::local_ped.in_vehicle())
                continue;



            uintptr_t vehicle = memory::Read<uintptr_t>(game::local_player + offsets::vehicle_offset);
            uintptr_t handling = memory::Read<uintptr_t>(vehicle + offsets::handling_offset);

            //uintptr_t model_info = memory::Read<uintptr_t>(vehicle + 0x20);
            //memory::Write<uint16_t>(model_info + 0x058B, 60);

            if (globals::toggles::horn_boost && GetAsyncKeyState(0x45))
                sdk::c_vehicle::c_handling::set_acceleration(vehicle, 1000.f);
            else
                sdk::c_vehicle::c_handling::set_acceleration(vehicle, globals::acceleration);
            sdk::c_vehicle::c_handling::set_brake_force(vehicle, globals::brake_force);
            sdk::c_vehicle::c_handling::set_down_force(vehicle, globals::downforce);


            sdk::c_vehicle::set_godmode(vehicle, globals::toggles::vehicle_godmode);
        }

    }

    namespace hotkeys {

        void toggler()
        {
            while (true)
            {
                Sleep(1);

                if (GetAsyncKeyState(globals::keys::magic_bullet_key))
                {
                    globals::toggles::magic_bullet = !globals::toggles::magic_bullet;
                    std::string text = "Magic Bullet " + std::string(globals::toggles::magic_bullet ? "Activated" : "Disabled");
                    notificationManager.addNotification(text, 5.0f);
                    Sleep(400);
                }

                if (GetAsyncKeyState(globals::keys::fire_ammo_key))
                {
                    globals::toggles::fire_ammo = !globals::toggles::fire_ammo;
                    std::string text = "Fire Ammo " + std::string(globals::toggles::fire_ammo ? "Activated" : "Disabled");
                    notificationManager.addNotification(text, 5.0f);
                    Sleep(400);
                }

                if (GetAsyncKeyState(globals::keys::explosive_ammo_key))
                {
                    globals::toggles::explosive_ammo = !globals::toggles::explosive_ammo;
                    std::string text = "Explosive Ammo " + std::string(globals::toggles::explosive_ammo ? "Activated" : "Disabled");
                    notificationManager.addNotification(text, 5.0f);
                    Sleep(400);
                }
                if (GetAsyncKeyState(globals::keys::explosive_melee_key))
                {
                    globals::toggles::explosive_melee = !globals::toggles::explosive_melee;
                    std::string text = "Explosive Melee " + std::string(globals::toggles::explosive_melee ? "Activated" : "Disabled");
                    notificationManager.addNotification(text, 5.0f);
                    Sleep(400);
                }
            }
        }

        void heal()
        {
            while (true)
            {
                Sleep(50);

                if (GetForegroundWindow() != game::hwnd)
                    continue;

                if (!globals::toggles::heal_key)
                    continue;

                if (!game::world)
                    continue;

                if (!game::local_player)
                    continue;

                if (GetAsyncKeyState(globals::keys::heal_key)) {
                    float health = memory::Read<float>(game::local_player + 0x280);
                    float armor = memory::Read<float>(game::local_player + 0x280);

                    float heal_amount = health + globals::healkey_health_amount;

                    if (heal_amount > 200.f)
                        heal_amount = 200.f;

                    float armor_amount = armor + globals::healkey_armor_amount;

                    if (armor_amount > 100.f)
                        armor_amount = 100.f;

                    memory::Write<float>(game::local_player + 0x280, heal_amount);
                    memory::Write<float>(game::local_player + offsets::armor_offset, armor_amount);
                    notificationManager.addNotification("Healed", 5.0f);
                    Sleep(400);
                }

            }
        }
    }

    void auto_heal()
    {
        while (true)
        {
            Sleep(1);

            if (!globals::toggles::auto_heal)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;

            Sleep(globals::heal_delay * 1000);
            float health = memory::Read<float>(game::local_player + 0x280);

            if (health < globals::minimum_hp)
                memory::Write<float>(game::local_player + 0x280, health + globals::heal_amount);
        }
    }

    void auto_armor()
    {
        while (true)
        {
            Sleep(1);

            if (!globals::toggles::auto_armor)
                continue;

            if (!game::world)
                continue;

            if (!game::local_player)
                continue;


            Sleep(globals::armor_delay * 1000);

            float armor = memory::Read<float>(game::local_player + offsets::armor_offset);

            if (armor < globals::minimum_armor)
                memory::Write<float>(game::local_player + offsets::armor_offset, armor + globals::armor_amount);
        }
    }


}
