namespace sdk
{
    namespace c_ped
    {
        Vector3 get_origin(uint64_t c_ped)
        {
            return memory::Read<Vector3>(c_ped + 0x90);
        }

        bool in_vehicle(uint64_t c_ped)
        {
            uint8_t ped_task = memory::Read<uint8_t>(c_ped + offsets::task_offset);

            return ped_task & 64;
        }

        uint64_t get_vehicle(uint64_t c_ped)
        {
            return memory::Read<uint64_t>(c_ped + offsets::vehicle_offset);
        }

        uint64_t get_navigation(uint64_t c_ped)
        {
            return memory::Read<uint64_t>(c_ped + 0x30);
        }

        float get_health(uint64_t c_ped)
        {
            return memory::Read<float>(c_ped + 0x280);
        }

        float get_armor(uint64_t c_ped)
        {
            return memory::Read<float>(c_ped + offsets::armor_offset);
        }

        void set_origin(uint64_t c_ped, Vector3 v_position)
        {
            memory::Write<Vector3>(c_ped + 0x90, v_position);
            uint64_t c_navigation = get_navigation(c_ped);
            memory::Write<Vector3>(c_navigation + 0x50, v_position);
        }
    }
}
