namespace sdk
{
    // 48 85 C9 0F 84 ? ? ? ? 48 8B C4 48 89 58 08 48 89 68 10 48 89 70 18 48 89 78 20 41 54 41 56 41 57 48 81 EC ? ? ? ? 44 8A B1 2C 15 00 00

    class c_ped_pool {
    private:
        uint32_t size;
        uint64_t bit_array;
        uint32_t item_size;
        uint64_t ped_pool_base;
    public:
        c_ped_pool(uint64_t ped_pool) {
            size = memory::Read<uint32_t>(ped_pool + 0x10);
            bit_array = memory::Read<uint64_t>(ped_pool + 0x8);
            item_size = memory::Read<uint32_t>(ped_pool + 0x14);
            ped_pool_base = ped_pool;
        }


        bool is_valid() {
            return ped_pool_base != 0;
        }

        uint32_t get_size() {
            return size;
        }

        uint64_t get_ped(int index) {
            if (index < 0 || index >= size) {
                return 0;
            }

            BYTE flag = memory::Read<BYTE>(bit_array + index);
            __int64 mask = ~((__int64)(flag & 0x80 | (unsigned __int64)-(__int64)(flag & 0x80)) >> 63);
            uint64_t CPed = mask & (memory::Read<uint64_t>(ped_pool_base) + item_size * index);
            return CPed;
        }
    };
}
