namespace downloads {
    bool fileExists(const std::string& filename) {
        std::ifstream file(filename.c_str());
        return file.good();
    }

    bool createDirectories(const std::string& path) {
        if (CreateDirectoryA(path.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError())
            return true;
        else {
            if (CreateDirectoryA(path.c_str(), NULL) == 0) {
                DWORD lastError = GetLastError();
                if (lastError == ERROR_PATH_NOT_FOUND) {
                    // Try creating parent directories recursively
                    size_t pos = path.find_last_of("\\/");
                    if (pos != std::string::npos) {
                        std::string parent = path.substr(0, pos);
                        if (createDirectories(parent)) {
                            // Try creating current directory again
                            if (CreateDirectoryA(path.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError())
                                return true;
                        }
                    }
                }
            }
            return false;
        }
    }

    //void downloadFile(const std::string& url, const std::string& destination) {
    //    HRESULT hr = URLDownloadToFileA(NULL, url.c_str(), destination.c_str(), 0, NULL);
    //    if (hr == S_OK)
    //        std::cout << "File downloaded successfully to " << destination << std::endl;
    //    else
    //        std::cerr << "Error downloading file" << std::endl;
    //}

    //void checkAndDownload(const std::string& url, const std::string& destination) {
    //    if (!fileExists(destination)) {
    //        std::string folder = destination.substr(0, destination.find_last_of("\\"));
    //        if (createDirectories(folder)) {
    //            downloadFile(url, destination);
    //        }
    //        else {
    //            std::cerr << "Error creating directories" << std::endl;
    //        }
    //    }
    //}
}
