#include <windows.h>
#include <psapi.h>
#include <string>
#include <iostream>

#pragma comment(lib, "psapi.lib")

namespace spotify {
    struct song {
        std::string title, author;
    };

    song current_song;
    HWND spotify_hwnd;
    DWORD fivem_pid;

    std::string get_process_name(HWND hwnd) {
        DWORD processId = 0;
        GetWindowThreadProcessId(hwnd, &processId);

        if (processId == fivem_pid)
            return "";

        HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, processId);
        if (!hProcess) {
            return "";
        }

        char exePath[MAX_PATH] = { 0 };
        if (GetModuleFileNameExA(hProcess, nullptr, exePath, MAX_PATH)) {
            CloseHandle(hProcess);
            return std::string(exePath);
        }

        CloseHandle(hProcess);
        return "";
    }

    BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam) {
        std::string process_name = get_process_name(hwnd);

        if (process_name.empty()) {
            return TRUE;
        }

        if (process_name.find("Spotify.exe") == std::string::npos) {
            return TRUE;
        }

        char className[256] = { 0 };

        if (GetClassNameA(hwnd, className, sizeof(className)) == 0) {
            return TRUE;
        }

        if (strcmp(className, "Chrome_WidgetWin_1") != 0) {
            return TRUE;
        }

        spotify_hwnd = hwnd;

        return FALSE;
    }

    void retrieve_song() {
        while (true) {
            Sleep(250);

            spotify_hwnd = nullptr;
            EnumWindows(EnumWindowsProc, 0);

            if (spotify_hwnd == nullptr) {
                current_song.title = "No song playing";
                current_song.author = "";
                continue;
            }

            char windowTitle[256] = { 0 };

            if (GetWindowTextA(spotify_hwnd, windowTitle, sizeof(windowTitle)) == 0) {
                current_song.title = "No song playing";
                current_song.author = "";
                continue;
            }

            std::string title(windowTitle);

            size_t separator_pos = title.find(" - ");
            if (separator_pos != std::string::npos) {
                current_song.author = title.substr(0, separator_pos);
                current_song.title = title.substr(separator_pos + 3);
            }
            else {
                current_song.title = "No song playing";
                current_song.author = "";
            }

        }
    }
}
